
class Report
  attr_reader :title, :text
  attr_accessor :formatter

  def initialize(formatter)
    @title = '月次報告'
    @text = ['順調','さいこ〜〜〜']
    @fomatter = formatter
  end

  def output_report
    @fomatter.output_report(self)
  end
end

class HTMLFormatter
  def output_report(context)
    puts '<html>'
    puts ' <head>'
    puts ' <meta charset="UTF-8">'
    puts " <title>#{context.title}</title>"
    puts ' </head>'
    puts ' <body>'
    context.text.each{|line|
      puts(" <p>#{line}</p>")
    }
    puts ' </body>'
    puts '</html>'
  end
end

class PlainTextFormatter
  def output_report(context)
    puts " ***#{context.title}***"
    context.text.each{|line|
      puts(" #{line}\n")
    }
  end
end

report = Report.new(HTMLFormatter.new)
report.output_report

report = Report.new(PlainTextFormatter.new)
report.output_report


